#include <stdio.h>
#define MAXSET 10
int set_construct (int set[ ]);
int set_union (int set[ ], int set1[ ], int set2[ ], int num1, int num2);
int set_intersection (int set[ ], int set1[ ], int set2[ ], int num1, int num2);
int set_is_member (int set[ ], int element, int num);

main( )
{
   int set[MAXSET], set1[MAXSET], set2[MAXSET], select, num, num1, num2, i;
   while (1) {
      printf("select menu 1.union 2.intersection 3.exit => ");
      scanf("%d", &select);
      if (select == 1) {
         num1 = set_construct(set1);
         num2 = set_construct(set2);
         num = set_union(set, set1, set2, num1, num2);
      } else if (select == 2) {
         num1 = set_construct(set1);
         num2 = set_construct(set2);
         num = set_intersection(set, set1, set2, num1, num2);
      } else if (select == 3) {
         for (i=0; i<num; i++)
            printf("%d ", set[i]);
         printf("\n");
         break;
      } else {
         printf("select error\n");
      }
   }
}

int set_construct (int set[ ])
{
   int num, i;
   printf("input the number of elements => ");
   scanf("%d", &num);
   for (i=0; i<num; i++) {
      printf("input element => ");
      scanf("%d", &set[i]);
   }
   return num;
}

int set_union (int set[ ], int set1[ ], int set2[ ], int num1, int num2)
{
   int i, num;
   for (num=0; num<num1; num++)
      set[num] = set1[num];
   for (i=0; i<num2; i++) {
      if (set_is_member(set1, set2[i], num1))
         continue;
      else if (num < MAXSET)
         set[num++] = set2[i];
      else {
         printf("set is full\n");
         break;
      }
   }
   return num;
}

int set_intersection (int set[], int set1[], int set2[], int num1, int num2)
{
   int i, num=0;
   for (i=0; i<num1; i++) {
      if (set_is_member(set2, set1[i], num2))
         set[num++] = set1[i];
   }
   return num;
}

int set_is_member (int set[], int element, int num)
{
   int i;
   for (i=0; i<num; i++)
      if (set[i] == element)
         return 1;
   return 0; 
}
